/*
 * ۼ ¥: 2005. 9. 21.
 *
 */
package test.openlbs.db;

//import java.sql.PreparedStatement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import com.openlbs.common.property.Property;
import com.openlbs.common.util.SystemViewManager;
import com.openlbs.datamanager.SP_Query;
import com.openlbs.datamanager.SQLManager;
import com.openlbs.datamanager.SQLMetaFunction;
import com.openlbs.datamanager.SQLQuery;
import com.openlbs.datamanager.SQLQueryString;
import com.openlbs.polling.assistant.CommonProc;
import com.openlbs.polling.entity.PShapeData;

/**
 * @author hhjang97
 *
 * Geofence  óѴ.
 * 
 */
public class DBTest {

	private SQLManager sqlfunc = new SQLMetaFunction();
	private Property lp = Property.getInstance();
	
	public Vector vShape;

	
	public DBTest() {
		vShape = new Vector();
	}
	
	
	// DB  SELECT  ׽Ʈ
	public void selectTest() {
		ResultSet rs = null;
		String sql = null;
		try {
			if(!sqlfunc.mConnection(lp.DB_PROPERTY_NAME)){ 
				System.out.println("DB Connection Error....");
			}



			sql = "SELECT * FROM tab";
			rs = sqlfunc.mSelect(sql);

			if (rs != null && rs.next()) {				
				System.out.println("DB  !!!");
			}


		} catch(Exception e){			
			e.printStackTrace();
			SystemViewManager.monitor(" DB Test error");
		} finally {
			try { if (rs != null) {rs.close(); rs = null;	}	} catch (Exception e) {}
			try { sqlfunc.mStmtCloseToIndex(sqlfunc.getMIndex());	}catch (Exception ex){}
			try{	sqlfunc.mConnectionClose();	}catch(SQLException seq){ seq.printStackTrace(); }
	
		}
		
	}
	
	
	// req_id شϴ geofence  ˻Ѵ.
	// tbl_prshape  ˻ Ѵ.
	public Vector getGeofence(Vector vReqId) {
		vShape.removeAllElements();
		int testType = 2;	// 1 : ⺻ ׽Ʈ   2: ׽Ʈ
		
		String reqId = null;
		
		ResultSet rs = null;
		PreparedStatement pstmt = null;

		String sql = null;
		
		try{
			
			if(!sqlfunc.mConnection(lp.DB_PROPERTY_NAME)){ 
				System.out.println("DB Connection Error....");
			}
 
			SQLQuery sqlQuery = new SQLQueryString();
			SP_Query sqlObj = (SP_Query)sqlQuery.getQueryObj(lp.POLLING_REPORT_SQL);
			
			// WORK : ϴ ׳ϰ  ߰Ѵ.
			// polling_geoinfo();

			
			if (testType == 1) {
				sql = "SELECT msid, phonetype, name FROM TBL_MSID WHERE msid=? ";
				pstmt = (sqlfunc.getMConnection()).prepareStatement(sql);
			} else {
				// req_id  char ΰ ?  char   Ѵ.
				if (testType == 2) {
					sql = "SELECT req_id FROM tbl_prshape WHERE req_id = ? ";
				} else {
					sql = "SELECT req_id FROM tbl_prshape WHERE area_type = ? ";
				}
				
				
				SystemViewManager.debug("SqlQuery :"+sql);
				pstmt = (sqlfunc.getMConnection()).prepareStatement(sql);				
			}
			
			
			
			try{
				for (int i=0, max = vReqId.size(); i<max; i++) {
					reqId = (String)vReqId.get(i);
//					System.out.println("reqid :"  +reqId);
			
					// Shape ˻
					if (testType == 1) {
						pstmt.setString(1, "01034880232");
					} else {
						if (testType == 2) {
							pstmt.setString(1, reqId);							
						} else {
							pstmt.setInt(1, 1);
						}
						
					}
					
					//rs = pstmt.executeQuery();
					rs = sqlfunc.mSelectPreparedStatement(pstmt);
					

					if (rs.next()) {
						if (testType == 1) {
							System.out.println("msid : " + rs.getString("msid") );
						} else {
							System.out.println("req_id : " + rs.getString("req_id") );
						}
						
					
					} else {
						SystemViewManager.monitor("reqid ˻  :" + reqId);
					}
					
					rs.close(); rs = null;
				}
				
				
			} catch(SQLException se){
				SystemViewManager.monitor("req_id search retrive error : " + se.getMessage());
			}
			
	
		} catch(Exception e){
			
			SystemViewManager.monitor("req_id search error");
			e.printStackTrace();
		}finally{
//			try{if(pstmt != null) sqlfunc.mPreparedStatementClose(pstmt); } catch (Exception ex){}

			try{
				sqlfunc.mStmtCloseToIndex(sqlfunc.getMIndex());
				sqlfunc.mConnectionClose();
			}catch(SQLException seq){ seq.printStackTrace(); }
		}
	
		return vShape;
	}
	
	public static void main(String[] args) {
		DBTest geo = new DBTest();
		
//		CommonProc rp = CommonProc.generalProc();
//		Vector vReqid = rp.getReqIds("01190255543");
//
//		Vector vShape = geo.getGeofence(vReqid);
//		System.out.println("vShape.size() :"  +vShape.size());
		
		geo.selectTest();
	}

}
